Bug 843139 (CVE-2012-3400)

Summary: CVE-2012-3400 kernel: udf: buffer overflow when parsing sparing table
Product: [Other] Security Response Reporter: Petr Matousek <pmatouse>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED ERRATA QA Contact:
Severity: low Docs Contact:
Priority: low    
Version: unspecifiedCC: agordeev, anton, bhu, davej, dhoward, fhrbata, gansalmon, itamar, jforbes, jkacur, jonathan, jwboyer, kernel-maint, kernel-mgr, kzhang, lgoncalv, lwang, madhu.chinakonda, plougher, rt-maint, sforsber, vgoyal, williams
Target Milestone: ---Keywords: Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard: impact=low,public=20120627,reported=20120703,source=oss-security,cvss2=6.2/AV:L/AC:H/Au:N/C:C/I:C/A:C,rhel-5/kernel=affected,rhel-6/kernel=affected,rhel-4/kernel=wontfix,mrg-1/realtime-kernel=wontfix,mrg-2/realtime-kernel=affected,fedora-all/kernel=affected
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2013-08-24 09:14:01 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On: 843140, 843141, 843142, 843143, 843144, 843145, 843146    
Bug Blocks: 843149    

Description Petr Matousek 2012-07-25 13:15:13 EDT
Description of problem:

A specially-crafted UDF filesystem could cause buffer overflow when parsing sparing tables in udf_load_logicalvol()@fs/udf/super.c.

The bug is fixed in upstream kernel via the following commits:


commit 1df2ae31c724e57be9d7ac00d78db8a5dabdd050
Author: Jan Kara <jack () suse cz>
Date:   Wed Jun 27 21:23:07 2012 +0200

    udf: Fortify loading of sparing table

    Add sanity checks when loading sparing table from disk to avoid accessing
    unallocated memory or writing to it.

and

commit adee11b2085bee90bd8f4f52123ffb07882d6256
Author: Jan Kara <jack () suse cz>
Date:   Wed Jun 27 20:20:22 2012 +0200

    udf: Avoid run away loop when partition table length is corrupted
    
    Check provided length of partition table so that (possibly maliciously)
    corrupted partition table cannot cause accessing data beyond current buffer.

Upstream fixes:
http://git.kernel.org/?p=linux/kernel/git/torvalds/linux.git;a=commitdiff;h=1df2ae31c724e57be9d7ac00d78db8a5dabdd050
http://git.kernel.org/?p=linux/kernel/git/torvalds/linux.git;a=commitdiff;h=adee11b2085bee90bd8f4f52123ffb07882d6256
http://git.kernel.org/?p=linux/kernel/git/torvalds/linux-2.6.git;a=commitdiff;h=57b9655d

References:
http://seclists.org/oss-sec/2012/q3/2
Comment 3 Petr Matousek 2012-07-25 13:20:07 EDT
Created kernel tracking bugs for this issue

Affects: fedora-all [bug 843146]
Comment 4 Petr Matousek 2012-07-25 13:21:29 EDT
Statement:

This issue does affect the versions of the Linux kernel as shipped with Red
Hat Enterprise Linux 5, 6 and Red Hat Enterprise MRG 2.

The Red Hat Security Response Team has rated this issue as having low security 
impact. A future kernel updates may address this issue. For additional 
information, refer to the Issue Severity Classification:
https://access.redhat.com/security/updates/classification/.
Comment 11 errata-xmlrpc 2012-11-06 13:17:57 EST
This issue has been addressed in following products:

  Red Hat Enterprise Linux 6

Via RHSA-2012:1426 https://rhn.redhat.com/errata/RHSA-2012-1426.html
Comment 12 errata-xmlrpc 2012-12-04 14:58:34 EST
This issue has been addressed in following products:

  MRG for RHEL-6 v.2

Via RHSA-2012:1491 https://rhn.redhat.com/errata/RHSA-2012-1491.html
Comment 13 errata-xmlrpc 2013-03-05 16:03:50 EST
This issue has been addressed in following products:

  Red Hat Enterprise Linux 5

Via RHSA-2013:0594 https://rhn.redhat.com/errata/RHSA-2013-0594.html